﻿using System;
using System.Linq;
using System.Windows.Forms;


namespace Alden_USB_CTR_15
{
    public partial class Form1 : Form
    {

        public TextBox[] CountsDisplay;
        public CheckBox[] Counting;
        public uint seconds;

        public Form1()
        {
            InitializeComponent();
            CountsDisplay = new TextBox[16];
            Counting = new CheckBox[16];
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void c11_CheckedChanged(object sender, EventArgs e)
        {
            (sender as CheckBox).Text = (sender as CheckBox).Checked ? "Counting" : "";
        }
        private void init()
        {
            timer1.Enabled = false;
            for (uint i = 0; i < 15; i++)
            {
                Control[] edits = this.Controls.Find("textBox" + (i + 1).ToString(), true);
                edits[0].Text += " foo " + i.ToString();
                CountsDisplay[i] = edits[0] as TextBox;
                CountsDisplay[i].Text = "0";

                Control[] checks = this.Controls.Find("c" + i.ToString().PadLeft(2, '0'), true);
                Counting[i] = checks[0] as CheckBox;
                Counting[i].Checked = false;

                AIOUSBNet.AIOUSB.CTR_8254ModeLoad(AIOUSBNet.AIOUSB.diOnly, 0, i, 2, 0);

            }
            timer1.Enabled = true;
        }
        private void buttonInit_Click(object sender, EventArgs e)
        {
            uint status = AIOUSBNet.AIOUSB.ResolveDeviceIndex(AIOUSBNet.AIOUSB.diOnly);
            Text = status.ToString();

            init();      
        }

        private void buttonRead_Click(object sender, EventArgs e)
        {
           
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            for (uint i = 0; i < CountsDisplay.Length - 1; i++)
            {
                ushort v = 0;
                byte s = 0;
                AIOUSBNet.AIOUSB.CTR_8254ReadStatus(AIOUSBNet.AIOUSB.diOnly, 0, i, ref v, ref s);

                if ((s & 0b01000000) == 0)
                {
                    Counting[i].Checked = true;
                    CountsDisplay[i].Text = v.ToString() + " : " + s.ToString("X2");
                }
                else
                {
                    Counting[i].Checked = false;
                    CountsDisplay[i].Text = "";
                }

            }
        }

        private void logPath_TextChanged(object sender, EventArgs e)
        {
            
        }

        private void textBox17_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {

        }
        private bool nonNumberEntered = false;
        private void textBox17_KeyDown(object sender, KeyEventArgs e)
        {
            // Initialize the flag to false.
            nonNumberEntered = false;

            // Determine whether the keystroke is a number from the top of the keyboard.
            if (e.KeyCode < Keys.D0 || e.KeyCode > Keys.D9)
            {
                // Determine whether the keystroke is a number from the keypad.
                if (e.KeyCode < Keys.NumPad0 || e.KeyCode > Keys.NumPad9)
                {
                    // Determine whether the keystroke is a backspace.
                    if (e.KeyCode != Keys.Back)
                    {
                        // A non-numerical keystroke was pressed.
                        // Set the flag to true and evaluate in KeyPress event.
                        nonNumberEntered = true;
                    }
                }
            }
            //If shift key was pressed, it's not a number.
            if (Control.ModifierKeys == Keys.Shift)
            {
                nonNumberEntered = true;
            }
        }

        private void textBox17_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Check for the flag being set in the KeyDown event.
            if (nonNumberEntered == true)
            {
                // Stop the character from being entered into the control since it is non-numerical.
                e.Handled = true;
            }
        }

        private void logSeconds_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            
            if (!uint.TryParse(logSeconds.Text, out seconds))
            {
                errorProvider1.SetError(logSeconds, "ew that's no good!");
                e.Cancel = true;
            }  
            if (seconds > 429)
            {
                errorProvider1.SetError(logSeconds, "too many seconds (must be less than 430)");
                e.Cancel = true;
            }
        }

        private void logSeconds_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(logSeconds, "");
            if (seconds == 1)
                buttonLog.Text = "LOG COUNTS (" + seconds.ToString() + " second)";
            else
                buttonLog.Text = "LOG COUNTS (" + seconds.ToString() + " seconds)";
            
        }

        private void buttonLog_Click(object sender, EventArgs e)
        {
            init();

        }
    }
}
